Attribute VB_Name = "modGetFiles"
Option Explicit

Public Function FindFiles(ByVal Path As String, ByRef files As Collection, _
 Optional ByVal Pattern As String = "*.*", Optional ByVal Attributes As VbFileAttribute = vbNormal, _
 Optional ByVal Recursive As Boolean = True, Optional OnlyNotInUse As Boolean = False) As Long
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010
50020  'Const vbErr_PathNotFound = 76
50030  Const INVALID_VALUE = -1
50040  Dim FileAttr As Long, filename As String, hFind As Long, WFD As WIN32_FIND_DATA
50050
50060  Path = CompletePath(Path)
50070
50080  If files Is Nothing Then
50090   Set files = New Collection
50100  End If
50110  Pattern = LCase$(Pattern)
50120
50130  hFind = FindFirstFileA(Path & "*", WFD)
50140  If hFind = INVALID_VALUE Then
50150   Exit Function
50160 '  Err.Raise vbErr_PathNotFound
50170  End If
50180
50190  Do
50200   filename = LeftB$(WFD.cFileName, InStrB(WFD.cFileName, vbNullChar))
50210   FileAttr = GetFileAttributesA(Path & filename)
50220   If FileAttr And vbDirectory Then
50230     If Recursive Then
50240      If FileAttr <> INVALID_VALUE And filename <> "." And filename <> ".." Then
50250       FindFiles = FindFiles + FindFiles(Path & filename, files, Pattern, Attributes)
50260      End If
50270     End If
50280    Else
50290     If (FileAttr And Attributes) = Attributes Then
50300      If LCase$(filename) Like Pattern Then
50310       FindFiles = FindFiles + 1
50320       If OnlyNotInUse = False Then
50330         AddFile files, Path, filename
50340        Else
50350         If FileInUse(Path & filename) = False Then
50360          AddFile files, Path, filename
50370         End If
50380       End If
50390      End If
50400     End If
50410   End If
50420  Loop While FindNextFileA(hFind, WFD)
50430  FindClose hFind
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGetFiles", "FindFiles")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Sub AddFile(ByRef files As Collection, Path As String, filename As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim spoolFile As clsSpoolFile
50020  Set spoolFile = New clsSpoolFile
50030  spoolFile.Path = Path
50040  spoolFile.fullFileName = CompletePath(Path) & filename
50050  spoolFile.FileLen = GetFileLength(Path & filename)
50060  spoolFile.FileDateTime = FileDateTime(Path & filename)
50070  spoolFile.FileDateTimeJobIdKey = GetFileDateTimeString(FileDateTime(Path & filename))
50080  files.Add spoolFile, spoolFile.fullFileName
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGetFiles", "AddFile")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Function GetFileDateTimeString(value As Date) As String
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  GetFileDateTimeString = Format$(value, "yyyymmddhhMMss")
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGetFiles", "GetFileDateTimeString")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

